%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%global full_release ironic-%{version}

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

Name:           openstack-ironic
# Liberty semver reset
# https://review.openstack.org/#/q/I1a161b2c1d1e27268065b6b4be24c8f7a5315afb,n,z
Epoch:          1
Summary:        OpenStack Baremetal Hypervisor API (ironic)
Version:        5.1.3
Release:        2%{?dist}
License:        ASL 2.0
Group:          System Environment/Base
URL:            http://www.openstack.org
Source0:        http://tarballs.openstack.org/ironic/ironic-%{version}%{?milestone}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=5.1.3
Patch0001: 0001-Tempest-Backward-get-admin-credential.patch

Source1:        openstack-ironic-api.service
Source2:        openstack-ironic-conductor.service
Source3:        ironic-rootwrap-sudoers
Source4:        ironic-dist.conf
Source5:        ironic.logrotate

BuildArch:      noarch
BuildRequires:  python-setuptools
BuildRequires:  python-devel
BuildRequires:  python-pbr
BuildRequires:  openssl-devel
BuildRequires:  libxml2-devel
BuildRequires:  libxslt-devel
BuildRequires:  gmp-devel
BuildRequires:  python-sphinx
BuildRequires:  systemd

%prep
%setup -q -n ironic-%{upstream_version}

%patch0001 -p1

rm requirements.txt test-requirements.txt

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}
install -p -D -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-ironic

# install systemd scripts
mkdir -p %{buildroot}%{_unitdir}
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}

# install sudoers file
mkdir -p %{buildroot}%{_sysconfdir}/sudoers.d
install -p -D -m 440 %{SOURCE3} %{buildroot}%{_sysconfdir}/sudoers.d/ironic

mkdir -p %{buildroot}%{_sharedstatedir}/ironic/
mkdir -p %{buildroot}%{_localstatedir}/log/ironic/
mkdir -p %{buildroot}%{_sysconfdir}/ironic/rootwrap.d

#Populate the conf dir
install -p -D -m 640 etc/ironic/ironic.conf.sample %{buildroot}/%{_sysconfdir}/ironic/ironic.conf
install -p -D -m 640 etc/ironic/policy.json %{buildroot}/%{_sysconfdir}/ironic/policy.json
install -p -D -m 640 etc/ironic/rootwrap.conf %{buildroot}/%{_sysconfdir}/ironic/rootwrap.conf
install -p -D -m 640 etc/ironic/rootwrap.d/* %{buildroot}/%{_sysconfdir}/ironic/rootwrap.d/

# Install distribution config
install -p -D -m 640 %{SOURCE4} %{buildroot}/%{_datadir}/ironic/ironic-dist.conf

%description
Ironic provides an API for management and provisioning of physical machines

%package common
Summary: Ironic common

Requires:   ipmitool
Requires:   python-dracclient
Requires:   python-eventlet
Requires:   python-futurist
Requires:   python-greenlet
Requires:   python-ironic-lib
Requires:   python-iso8601
Requires:   python-posix_ipc
Requires:   python-jsonpatch
Requires:   python-keystonemiddleware
Requires:   python-kombu
Requires:   python-anyjson
Requires:   python-lockfile
Requires:   python-lxml
Requires:   python-migrate
Requires:   python-mock
Requires:   python-netaddr
Requires:   python-oslo-concurrency
Requires:   python-oslo-config
Requires:   python-oslo-context
Requires:   python-oslo-db
Requires:   python-oslo-i18n
Requires:   python-oslo-log
Requires:   python-oslo-messaging
Requires:   python-oslo-middleware
Requires:   python-oslo-policy
Requires:   python-oslo-rootwrap
Requires:   python-oslo-serialization
Requires:   python-oslo-service
Requires:   python-oslo-utils
Requires:   python-oslo-versionedobjects
Requires:   python-paramiko
Requires:   python-pecan
Requires:   python-proliantutils
Requires:   python-psutil
Requires:   python-retrying
Requires:   python-six
Requires:   python-stevedore
Requires:   python-webob
Requires:   python-websockify
Requires:   python-wsme
Requires:   pycrypto
Requires:   python-sqlalchemy
Requires:   python-neutronclient
Requires:   python-glanceclient
Requires:   python-keystoneclient
Requires:   python-swiftclient
Requires:   python-jinja2
Requires:   python-pyghmi
Requires:   python-alembic
Requires:   pysendfile
Requires:   python-pbr
Requires:   python-automaton
Requires:   python-requests
Requires:   python-jsonschema
Requires:   pytz


Requires(pre):  shadow-utils

%description common
Components common to all OpenStack Ironic services


%files common
%doc README.rst LICENSE
%{_bindir}/ironic-dbsync
%{_bindir}/ironic-rootwrap
%{python2_sitelib}/ironic*
%exclude %{python2_sitelib}/ironic/tests
%exclude %{python2_sitelib}/ironic_tempest_plugin
%{_sysconfdir}/sudoers.d/ironic
%config(noreplace) %{_sysconfdir}/logrotate.d/openstack-ironic
%config(noreplace) %attr(-,root,ironic) %{_sysconfdir}/ironic
%attr(-,ironic,ironic) %{_sharedstatedir}/ironic
%attr(0750,ironic,ironic) %{_localstatedir}/log/ironic
%attr(-, root, ironic) %{_datadir}/ironic/ironic-dist.conf

%pre common
getent group ironic >/dev/null || groupadd -r ironic
getent passwd ironic >/dev/null || \
    useradd -r -g ironic -d %{_sharedstatedir}/ironic -s /sbin/nologin \
-c "OpenStack Ironic Daemons" ironic
exit 0

%package api
Summary: The Ironic API

Requires: %{name}-common = %{epoch}:%{version}-%{release}

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description api
Ironic API for management and provisioning of physical machines


%files api
%doc LICENSE
%{_bindir}/ironic-api
%{_unitdir}/openstack-ironic-api.service

%post api
%systemd_post openstack-ironic-api.service

%preun api
%systemd_preun openstack-ironic-api.service

%postun api
%systemd_postun_with_restart openstack-ironic-api.service

%package conductor
Summary: The Ironic Conductor

Requires: %{name}-common = %{epoch}:%{version}-%{release}

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description conductor
Ironic Conductor for management and provisioning of physical machines

%files conductor
%doc LICENSE
%{_bindir}/ironic-conductor
%{_unitdir}/openstack-ironic-conductor.service

%post conductor
%systemd_post openstack-ironic-conductor.service

%preun conductor
%systemd_preun openstack-ironic-conductor.service

%postun conductor
%systemd_postun_with_restart openstack-ironic-conductor.service

%package -n python-ironic-tests
Summary:        Ironic tests
Requires:       %{name}-common = %{epoch}:%{version}-%{release}

%description -n python-ironic-tests
This package contains the Ironic test files.

%files -n python-ironic-tests
%license LICENSE
%{python2_sitelib}/ironic/tests
%{python2_sitelib}/ironic_tempest_plugin

%changelog
* Wed Nov 22 2017 Derek Higgins <derekh@redhat.com> 1:5.1.3-2
- Fix log dir world readable permissions

* Fri Oct 20 2017 Jon Schlueter <jschluet@redhat.com> 1:5.1.3-1
- Update to 5.1.3 (rhbz#1365881)
- Fix updating port MAC address for active nodes (rhbz#1365881)

* Fri Jul 15 2016 Thierry Vignaud <<tvignaud@redhat.com>> 1:5.1.2-3
- Tempest: Backward get admin credential (rhbz#1356092)

* Tue Jun 28 2016 Thierry Vignaud <<tvignaud@redhat.com>> 1:5.1.2-2
- Updated from global requirements
- remove neutron stuff from devstack deb packages

* Wed Jun 22 2016 Mike Burns <mburns@redhat.com> 1:5.1.2-1
- Update to 5.1.2
- Mask password on agent lookup according to policy rhbz#1348041

* Mon Jun 20 2016 Mike Burns <mburns@redhat.com> 1:5.1.0-4
- Change port used for Ironic static http to 3928

* Tue Jun 07 2016 Mike Burns <mburns@redhat.com> 1:5.1.0-3
- tempest: start using get_configured_admin_credentials
- Stop unit-testing processutils internals
- Update compute_driver in documentation
- Fix usage of rest_client expected_success() in tests
- Updated from global requirements
- Enable download of tinyipa prebuilt image
- use stable/mitaka upper-constraints
- pull mitaka release notes from the mitaka branch
- Update tempest compute flavor_ref/flavor_ref_alt
- Updated from global requirements
- Force iRMC vmedia boot from remotely connected CD/DVD
- Updated from global requirements
- Normalize MAC OctetString to fix InvalidMAC exception
- Allow fetching IPA ramdisk with branch name

* Tue Jun 07 2016 Mike Burns <mburns@redhat.com> 1:5.1.0-2


* Thu Mar 24 2016 RDO <rdo-list@redhat.com> 5.1.0-1
- 5.1.0 Rebuild for Mitaka
